#  Copyright (c) PARRRATE T&V 2021. All rights reserved.

from bu4.encoding.codes import CODE_XCPT
from bu4.evaluation.constructs.eexception import EException
from bu4.evaluation.constructs.evaluable import Evaluable
from bu4.indexing.constructs.indexed import Indexed
from bu4.indexing.evaluation.eivtype import eivtype
from bu4.transform.states.transformfinished import TransformFinished
from bu4.transform.states.transformstate import TransformState

__all__ = ('IException',)


class IException(Indexed):
    def __init__(self, name: bytes):
        self.name = name

    def attach(self, ev: eivtype) -> Evaluable:
        return EException(self.name)

    def __str__(self):
        return f'«{self.name.decode()}»'

    def bytes(self) -> TransformState[bytes]:
        return TransformFinished(bytes([CODE_XCPT, *self.name, 0]))
