#  Copyright (c) PARRRATE T&V 2021. All rights reserved.

from bu4.encoding.codes import CODE_NAME
from bu4.evaluation.constructs.evaluable import Evaluable
from bu4.indexing.constructs.indexed import Indexed
from bu4.indexing.evaluation.eivtype import eivtype
from bu4.transform.states.transformfinished import TransformFinished
from bu4.transform.states.transformstate import TransformState

__all__ = ('IName',)


class IName(Indexed):
    def __init__(self, index: int):
        self.index = index

    def attach(self, ev: eivtype) -> Evaluable:
        return ev[self.index]

    def __str__(self):
        return f'[[{self.index}]]'

    def bytes(self) -> TransformState[bytes]:
        return TransformFinished(bytes([CODE_NAME, self.index]))
