#  Copyright (c) PARRRATE T&V 2021. All rights reserved.

from bu4.encoding.codes import CODE_NULL
from bu4.evaluation.constructs.enull import ENull
from bu4.evaluation.constructs.evaluable import Evaluable
from bu4.indexing.constructs.indexed import Indexed
from bu4.indexing.evaluation.eivtype import eivtype
from bu4.transform.states.transformfinished import TransformFinished
from bu4.transform.states.transformstate import TransformState

__all__ = ('INull',)


class INull(Indexed):
    def attach(self, ev: eivtype) -> Evaluable:
        return ENull()

    def __str__(self):
        return '?'

    def bytes(self) -> TransformState[bytes]:
        return TransformFinished(bytes([CODE_NULL]))
